unit sertan;
interface

uses crt,dos,keyboard;

var scr:pointer;
    ckar,cfon:word;
    tab:boolean;
    menu:array[1..250] of string[20];

const etip=$b800;

procedure cls;
procedure flushkb;
procedure beep;
procedure buton(x,y,tip:byte;text:string);
function harf(sy:word;kr:char):string;
function textbx(x,y,cx,cy:BYTE;ntext:string):string;
function inputbx(gen:byte;text,ntext:string):string;
procedure renk(kar,fn:byte);
procedure yaz(x,y:byte;text:string);
procedure dur;
function buyuk(text:string):string;
function kucuk(text:string):string;
function duzen(text:string;lng:byte;tip:byte):string;
procedure savescr;
procedure getscr;
procedure firlat(tip:byte);
procedure kutu(x,y,sx,sy,tip:byte;golge:boolean);
function liste(x,y,sutun,satir,kar,fon,sayi:byte):byte;
procedure fon(kar,fon:byte);
procedure msg(gen:byte;text:string);
procedure off;
procedure on;
procedure buyon;

implementation

PROCEDURE CLS;begin clrscr;end;
procedure beep;
begin
sound(200);
delay(100);
nosound;
end;

Procedure FlushKB;           (* INT 21 function 0C *)
 Var Regs:Registers;         (* Flushes (erase) the keyboard buffer *)
  Begin                      (* ONLY. No other function is executed *)
   Regs.AH:=$0C;
   Regs.AL:=2;
   Intr ($21,Regs);
 End;


function harf;
var s:string;
begin
s:='';
fillchar(s,sy+1,kr);
s[0]:=chr(sy);
harf:=s;
end;

procedure yaz;
begin
gotoxy(x,y);
write(text);
end;

procedure renk;
begin
ckar:=kar;
cfon:=fn;
textbackground(fn);
textcolor(kar);
end;

procedure dur;
begin
flushkb;
repeat until keypressed;
end;

function buyuk;
var i:integer;cr:char;
begin
buyuk:=text;
for i:=1 to length(text) do begin
            cr:=text[i];
            case cr of
                 'i':buyuk[i]:='';
                 '':buyuk[i]:='';
                 '':buyuk[i]:='I';
                 '':buyuk[i]:='';
                 '':buyuk[i]:='';
                 '':buyuk[i]:='';
                 '':buyuk[i]:='';
                 else buyuk[i]:=upcase(cr);
            end;
end;
end;


function kucuk;
var i:integer;cr:char;
begin
kucuk:=text;
for i:=1 to length(text) do begin
            cr:=text[i];
            case cr of
                 '':kucuk[i]:='i';
                 '':kucuk[i]:='';
                 'I':kucuk[i]:='';
                 '':kucuk[i]:='';
                 '':kucuk[i]:='';
                 '':kucuk[i]:='';
                 '':kucuk[i]:='';
                 'A'..'Z':kucuk[i]:=chr(ord(cr)+32);
                 else kucuk[i]:=cr;
            end;
end;
end;

function duzen;
var a,b,c:word;
begin
case tip of
     1:begin;    a:=length(text);
                 if lng<a then exit;
                 b:=lng-a;
                 if not odd(b) then begin c:=b div 2;duzen:=harf(c,' ')+text+harf(c,' ');end
                               else begin c:=(b-1) div 2;duzen:=harf(c,' ')+text+harf(c+1,' ');end;
       end;
     2:duzen:=text+harf(lng,' ');
     3:duzen:=harf(lng,' ')+text;
end;
end;

procedure savescr;
begin
getmem(scr,4000);
move(ptr(etip,0)^,scr^,4000);
end;

procedure getscr;
begin
move(scr^,ptr(etip,0)^,4000);
freemem(scr,4000);
end;

procedure firlat(tip:byte);
type ekran=array [1..25,1..80,1..2] of char;
var ekr:ekran absolute $b800:0;
    now:ekran;
       i,j,k,l:integer;

begin
now:=ekr;
case tip of

1:for l:=1 to 80 do begin
for j:=1 to 25 do begin
ekr[j,1,1]:=#0;
ekr[j,1,2]:=#0;
for i:=2 to 80 do begin
for k:=1 to 2 do begin
   ekr[j,i,k]:=now[j,i-1,k];
   end;
 end;
end;
now:=ekr;
end;

2:for l:=1 to 80 do begin
for j:=1 to 25 do begin
ekr[j,80,1]:=#0;
ekr[j,80,2]:=#0;
for i:=1 to 79 do begin
for k:=1 to 2 do begin
   ekr[j,i,k]:=now[j,i+1,k];
   end;
 end;
end;
now:=ekr;
end;

4:begin
for i:=1 to 80 do begin
ekr[1,i,1]:=#0;
ekr[1,i,2]:=#0;
end;
for l:=1 to 25 do begin
for j:=2 to 25 do begin
for i:=1 to 80 do begin
for k:=1 to 2 do begin
   ekr[j,i,k]:=now[j-1,i,k];
   end;
 end;
end;
delay(30);
now:=ekr;
end;
end;

3:begin
for i:=1 to 80 do begin
ekr[25,i,1]:=#0;
ekr[25,i,2]:=#0;
end;
for l:=1 to 25 do begin
for j:=1 to 24 do begin
for i:=1 to 80 do begin
for k:=1 to 2 do begin
   ekr[j,i,k]:=now[j+1,i,k];
   end;
 end;
end;
delay(30);
now:=ekr;
end;
end;

5:begin
for i:=1 to 80 do begin
ekr[25,i,1]:=#0;
ekr[25,i,2]:=#0;
end;
for l:=1 to 25 do begin
for j:=1 to 24 do begin
ekr[j,1,1]:=#0;
ekr[j,1,2]:=#0;
for i:=2 to 80 do begin
for k:=1 to 2 do begin
   ekr[j,i,k]:=now[j+1,i-1,k];
   end;
 end;
end;
delay(40);
now:=ekr;
end;
end;


end; {case}
end;



procedure kutu;
var kare:array [1..6] of char;
    en,boy,i:integer;
   ekr:array [1..25,1..80,1..2] of char absolute $B800:0;

begin
case tip of
     1:begin kare[1]:='';
             kare[2]:='';
             kare[3]:='';
             kare[4]:='';
             kare[5]:='';
             kare[6]:='';
        end;
     2:begin kare[1]:='';
             kare[2]:='';
             kare[3]:='';
             kare[4]:='';
             kare[5]:='';
             kare[6]:='';
        end;
end;
en:=sx-x-2;
boy:=y-sy-2;
yaz(x,y,kare[1]+harf(en,kare[2])+kare[3]);
for i:=y+1 to sy-1 do yaz(x,i,kare[4]+harf(en,' ')+kare[4]);
yaz(x,sy,kare[6]+harf(en,kare[2])+kare[5]);
if golge then begin
    for i:=x+1 to sx+1 do ekr[sy+1,i,2]:=#$08;
    for i:=y+1 to sy do begin ekr[i,sx+1,2]:=#$08;
                              ekr[i,sx,2]:=#$08;
                        end;
end;
end;

procedure buton(x,y,tip:byte;text:string);
var lfon,lkar,l:word;
begin
lfon:=cfon;
lkar:=ckar;
l:=length(text)+2;
case tip of
0:begin renk(4,2);
        yaz(x,y,' '+text+' ');
        renk(0,lfon);
        yaz(x+1,y+1,harf(l,''));
        yaz(x+l,y,'');
        renk(lkar,lfon);
  end;
1:begin renk(4,2);
        yaz(x,y,' '+text+' ');
        yaz(x,y,chr(16));
        yaz(x+l-1,y,chr(17));
        renk(0,lfon);
        yaz(x+1,y+1,harf(l,''));
        yaz(x+l,y,'');
        renk(lkar,lfon);
  end;
2:begin renk(lkar,lfon);
        yaz(x,y,harf(l+1,' '));
        yaz(x,y+1,harf(l+1,' '));
        renk(4,2);
        yaz(x+1,y,' '+text+' ');
end;
end;
end;

function liste(x,y,sutun,satir,kar,fon,sayi:byte):byte;
var i:integer;a:char;
    item,don,lkar,lfon,t,sayf,sonsay:word;
begin
lkar:=ckar;
lfon:=cfon;
if sayi mod satir=0 then sonsay:=sayi div satir
else begin sonsay:=sayi div satir+1;t:=sayi mod satir;
           for i:=1 to satir-t do menu[sayi+i]:=harf(sutun,' ');
           end;
for i:=1 to sayi do menu[i]:=duzen(menu[i],sutun,1);
item:=1;don:=1;sayf:=1;
for i:=0 to satir-1 do yaz(x,y+i,menu[i+1]);
renk(kar,fon);
yaz(x,y,menu[1]);
repeat
repeat
if keypressed then a:=readkey;
until a in [#13,#80,#72,#73,#81];
case a of
     #80:begin if item<>sayi then begin if don<>satir then begin renk(lkar,lfon);
                                yaz(x,y+don-1,menu[item]);
                                don:=don+1;
                                item:=item+1;
                                renk(kar,fon);
                                yaz(x,y+don-1,menu[item]);
                                end
                                else begin renk(lkar,lfon);
                                     for i:=0 to satir-1 do
                                     yaz(x,y+i,menu[item+i+1]);
                                     item:=item+1;sayf:=sayf+1;
                                     renk(kar,fon);yaz(x,y,menu[item]);
                                     don:=1;
                                     end;
                                     end
                                     else beep;
a:=#0;
end;
   #72:begin if item<>1 then begin if don<>1 then begin renk(lkar,lfon);
                                yaz(x,y+don-1,menu[item]);
                                don:=don-1;item:=item-1;
                                renk(kar,fon);
                                yaz(x,y+don-1,menu[item]);
                                end
                                else begin renk(lkar,lfon);t:=item-satir-1;
                                for i:=0 to satir-1 do
                                    yaz(x,y+i,menu[t+i+1]);
                                    item:=item-1;sayf:=sayf-1;
                                renk(kar,fon);yaz(x,y+satir-1,menu[item]);
                                don:=satir;
                                end;
                                end
                                else beep;
                                a:=#0;
end;
    #73:begin if sayf<>1 then begin renk(lkar,lfon);sayf:=sayf-1;item:=(sayf-1)*satir+don;
                           for i:=0 to satir-1 do yaz(x,y+i,menu[item-don+i+1]);
                           renk(kar,fon);yaz(x,y+don-1,menu[item]);
                           end
                           else beep;a:=#0;
                           end;

    #81:begin if sayf<sonsay-1 then begin renk(lkar,lfon);sayf:=sayf+1;item:=(sayf-1)*satir+don;
                           for i:=0 to satir-1 do yaz(x,y+i,menu[item-don+i+1]);
                           renk(kar,fon);yaz(x,y+don-1,menu[item]);
                           end
                           else begin t:=sayi mod satir;
                           if sayf=sonsay then beep
                           else
                           begin
                           renk(lkar,lfon);sayf:=sayf+1;
                           for i:=0 to satir-1 do yaz(x,y+i,menu[(sonsay-1)*satir+i+1]);
                           renk(kar,fon);
                           if (don<t+1) or (t=0) then begin
                                         item:=(sayf-1)*satir+don;
                                         yaz(x,y+don-1,menu[item]);
                                         end
                                         else begin
                                         item:=sayi;don:=t;
                                         yaz(x,y+t-1,menu[item]);
                                         end;
                           end;
            end;
               a:=#0;
        end;
    #13:begin liste:=item;a:=#0;exit;end;
    #27:begin a:=#0;liste:=0;exit;end;

end;
until 1=2;
end;

procedure fon(kar,fon:byte);
var i:integer;
begin
textcolor(kar);
textbackground(fon);
for i:=1 to 25 do begin
                  gotoxy(1,i);write(harf(80,''));end;
renk(ckar,cfon);
end;

function inputbx(gen:byte;text,ntext:string):string;
var x:integer;
    c:string[30];
    lkar,lfon:byte;
    ok:boolean;
begin
lkar:=ckar;
lfon:=cfon;
savescr;
renk(0,7);
if odd(gen) then gen:=gen+1;
x:=(80-gen) div 2;
kutu(x,8,x+gen,14,1,true);
text:=duzen(text,gen-2,1);
yaz(x+1,9,text);
buton(33-gen div 8,13,1,'Tamam');
buton(40+gen div 8,13,0,'ptal');
ok:=true;
tab:=true;
c:=ntext;
repeat
c:=textbx(x+1,10,x+gen-1,12,c);
if ok then begin ok:=false;buton(33-gen div 8,13,0,'Tamam');
                 buton(40+gen div 8,13,1,'ptal');
           end
           else begin ok:=true;buton(33-gen div 8,13,1,'Tamam');
                      buton(40+gen div 8,13,0,'ptal');
           end;
until not tab;
inputbx:=c;
getscr;
renk(lkar,lfon);
end;

function textbx;
var c:string[50];
    a:char;
    ps:byte;
    ins:boolean;
begin
textbackground(7);
textcolor(0);
kutu(x,y,cx,cy,2,false);
textbackground(1);
textcolor(15);
yaz(x+1,11,ntext);
textbackground(7);
textcolor(0);
on;
c:='';
window(x+1,y+1,cx-2,cy-1);
a:=#0;
repeat
a:=#0;
a:=readkey;
case a of
     #211:begin ps:=(wherex);delete(c,wherex,1);C[0]:=chr(length(C)-1);yaz(1,1,c);gotoxy(ps,1);end;
     #203:if wherex <>1 then gotoxy(wherex-1,1);
     #205:gotoxy(wherex+1,1);
     #210:if ins then begin ins:=false;on;end else begin ins:=true;buyon;end;
     ' '..'':begin IF CAPSON THEN a:=upcase(a);
              if not ins then begin if wherex<length(c) then begin ps:=wherex;insert(a,c,wherex);gotoxy(ps+1,1);end
                                           else c:=c+a;
                                           end
                      else c[wherex]:=a;
                      yaz(1,1,c);
                      end;
     #8:begin delete(c,length(c),1);yaz(1,1,c);end;
     #9:tab:=true;
     #13:begin if c='' then c:=ntext;tab:=false;end;
end;
until (a=#13) or (a=#9);
textbx:=c;
window(1,1,80,25);
off;
end;

procedure msg(gen:byte;text:string);
var x:integer;
    c:string[30];
    lkar,lfon:byte;
    ok:boolean;
begin
lkar:=ckar;
lfon:=cfon;
savescr;
renk(4,3);
if odd(gen) then gen:=gen+1;
x:=(80-gen) div 2;
kutu(x,8,x+gen,14,1,true);
text:=duzen(text,gen-2,1);
renk(5,3);
yaz(x+1,9,text);
buton(x+gen div 2-4,12,1,'Tamam');
dur;
getscr;
renk(lkar,lfon);
end;



procedure off;
var r:registers;
begin
with r do
begin
ah:=$01;ch:=$20;cl:=$20;
end;
intr($10,r);
end;

procedure on;
var r:registers;
begin
with r do
begin
ah:=$01;ch:=12;cl:=13;
end;
intr($10,r);
end;

procedure buyon;
var r:registers;
begin
with r do
begin
ah:=$01;ch:=0;cl:=7;
end;
intr($10,r);
end;


end.


